
; Add 4th screen, displaying speed in Km/h and heading
; from $GPVTG sentence. (F5ITU 12/04/2004) mod param GPS HI-203E
; Routine : mod "keymonitor" 12/04 
; Routine : mod "screen_display" 12/04
; Routine : mod "main_loop" 12/04
; Routine : add routine "VTG" 12/04 (VTG sentence from NMEA protocol)
; Routine : add "screen4" 
; Routine : add "disp_vite" display vitesse en km/h
; Routine : add "disp_cap" affichage du cap 
;
;************************************************************************
; GPS display program for GPS RCVR Boards with NMEA protocol            *
;************************************************************************
; Version 1.4; 16-02-2004 by IW2BC - Pierbassano Turrini                * 
;************************************************************************
; uses 2 x 16 pos LCD screen for display                                *
; uses one pushbutton on RA2: pressed is LOW                            *
;************************************************************************
;       0. screen with    Latitude      speed
;			  Longitude	heading
;       1. screen with    time 
;          		  date
;       2. screen with    Latitude .xxx
;			  Longitude .yyy
;	3. screen with    n.Sat/HDOP/Altitude
;

;************************************************************************
; The LCD is being communicated with via a 4 bit interface.		*
; This requires twice the communications, but we can get by with half	*
; the pins...								*
; Port Configurations :                                                 *
;									*
; RB all outputs        						*
; RB0 : Enable                                                          *
; RB1 : RS                                                              *
; RB2 : not used                                                        *
; RB3 : not used                                                        *
; RB4 : LCD (B4) LSB                                                    *
; RB5 : LCD (B5)                                                        *
; RB6 : LCD (B6)                                                        *
; RB7 : LCD (B7) MSB                                                    *
;
; RA0 : Serial Input  (4800 bps 8N1) (from GPS Engine)                  *
; RA1 : Serial Output (4800 bps 8N1) (for later appl for NMEA output)   *
; RA2 : Toggles between screens                                         *
; RA3 : n/c                                                             *
; RA4 : n/c                                                             *
;									*

;************************************************************************
; processor pic16f84                                                    *
; no code protection                                                    *
; power up timer enabled                                                *
; WDT disabled		                                                *
; XT oscillator  (4 Mc)                                                 *
;************************************************************************
;************************************************************************
; This code is copyrighted by Pierbassano Turrini C.2003		*
; and is not to be used for any commercial purposes. It is NOT		*
; to be distributed either without the express consent of the		*
; author.                                                              *
; My work is free but with no garanties for anything.			*
;************************************************************************
     	processor 16f84
        include  "p16f84.inc"
        __config _CP_OFF & _PWRTE_ON & _WDT_OFF & _XT_OSC
        errorlevel	-302
;************************************************************************
#define         SERIAL_IN       porta, 0
;________________________________________________________________________
;       ram data start at location 0x0c
;
	org	0x0C			; variables
;
;       GPS-Data start here; 56 bytes transferred
;	Variabile name refered to sentence $GPRMC
;
dato1	res 1 		; h1 - time in UTC		$GPGGA
dato2	res 1		; h2
dato3	res 1		; m1
dato4	res 1		; m2
dato5	res 1		; s1
dato6	res 1		; s2
dato7	res 1		; dot1
dato8	res 1		; d1
dato9	res 1		; d2
dato10	res 1		; d3 - end time in UTC
dato11 	res 1		; comma1
dato12	res 1		; A/V - Validate		Lat1
dato13	res 1		; comma2
dato14 	res 1		; lat1 - latitude
dato15	res 1		; lat2
dato16	res 1		; lat_min1
dato17	res 1		; lat_min2
dato18	res 1		; dot2
dato19	res 1		; lat_dec1
dato20	res 1		; lat_dec2			end Lat
dato21 	res 1		; lat_dec3			comma2
dato22	res 1		; lat_dec4			N/S
dato23	res 1		; comma3			comma3
dato24	res 1		; N/S - end latitude		Lon1
dato25	res 1		; comma4
dato26	res 1		; lon1
dato27	res 1		; lon2
dato28	res 1		; lon3
dato29	res 1		; lon_min1
dato30	res 1		; lon_min2
dato31	res 1		; dot3
dato32	res 1		; lon_dec1
dato33	res 1		; lon_dec2			end Lon
dato34	res 1		; lon_dec3			comma4
dato35	res 1		; lon_dec4			E/W
dato36	res 1		; comma5			comma5
dato37	res 1		; E/W				validity
dato38	res 1		; comma6			comma6
dato39	res 1		; speed1			n sat1
dato40	res 1		; speed2			n sat2
dato41	res 1		; speed3			comma7
dato42	res 1		; dot4				
dato43	res 1		; speed_dec1
dato44	res 1		; comma7
dato45	res 1		; course1
dato46	res 1		; course2
dato47	res 1		; course3
dato48	res 1		; dot5
dato49	res 1		; course_dec1
dato50	res 1		; comma8
dato51	res 1		; d1 - start Date
dato52	res 1		; d2
dato53	res 1		; m1
dato54	res 1		; m2
dato55	res 1		; y1
dato56	res 1		; y2 - end Date

; end of raw data

rit1	res 1		; used in delay routines   
rit2	res 1		;  
screen	res 1  		; which screen is to be displayed		
bytelcd	res 1 		; contains byte sent to LCD routine
counter	res 1		; used as a general counter
temp	res 1		; used as temp by rev_write routine

;************************************************************************
;
;Register used by RS232 subroutines
;
serialData		res 1	;Shift register
serialCount		res 1	;Bit counter
serialDelayCount	res 1	;Delay counter
;
;
; DELAY_TIME should be (ClockSpeed/4/SerialSpeed-14)/3
; 4MHz 9600 baud would be (4000000/4/9600-14)/3 = 30
; 4MHz 2400=134 4800=65 9600=30 19200=13 38400=4 57600=1

; 10Mhz  4800=169
;
DELAY_TIME	equ	D'65'
;
;**********************************************************************
;
;       Define LCD Control Bits
; RW      equ     3			; not used
RS      equ     1
E       equ     0
;

;************************************************************************
;       MAIN PROGRAM AREA                                               *
;************************************************************************
        org      0x00                ; Reset Vector
        goto     main00

;************************************************************************
;************************************************************************
;       LCD routines
;************************************************************************
; LCD output. 4 bit nibble mode
;
;     initialization of display LCD
;         - 2 line 5x7
;         - operation 4 bit
;         - no cursor

inilcd
	
  call iniLCD_to_8
  call iniLCD_to_8
  call iniLCD_to_8

	movlw   b'00100001'             ; initialize to 4 bits
	movwf   PORTB
	bcf     PORTB,0			; reset enable
	call    del50
	movlw    b'00101000'            ; initialize to 4 bit, 2 line, 5x7 char
	call     cmdlcd                 ; send command
	movlw    b'00001100'            ; display on / cursor off
	call     cmdlcd                 ; send command
	movlw    b'00000100'		; Entry Mode:
					; increment cursor/display shift
	call     cmdlcd                 ; send command

;
;************************************************************************
;	Routine to home the cursor and clear the LCD (takes typical 1.64 msec)

clrLCD
	movlw    b'00000001'            ; clear LCD / home cursor
	call     cmdlcd                 ; send command
	return

iniLCD_to_8				; is part of inilcd s\r to save code space
	movlw   b'00110001'		; initialize to 8 bits
	movwf   PORTB
	bcf     PORTB,0			; reset enable
	call    del50
	return

;************************************************************************
;     Routine to send command to display LCD 4 bits at a time

cmdlcd
	movwf	 bytelcd		; save for second half
	andlw    b'11110000'		; Mask out bottom nibble
	iorlw    b'00000001'		; set RS = 0, ENA = 1
	movwf    portb			; move nibble to PORTB
	bcf      portb,e		; clock it in with enable
	call     delcd			; Wait just a moment
	swapf    bytelcd,w		; swap nibbles in bytelcd
	andlw    b'11110000'
	iorlw    b'00000001'  
	movwf    portb
	bcf      portb,e
	call     delcd
	call  del05
	return                

;************************************************************************
;	Routine to home the cursor on the second line of the display

send_CRLF	
	movlw    0xC0                   ; position cursor at far left bottom row
	call     cmdlcd                 ; send command
	return

;************************************************************************
;	Routine to send one blank character

sendBlank
        movlw   " "			; sends one blank character
        call	wrtlcd
	return
	
;************************************************************************
;       Routine to send a character to display LCD 4 bits at a time

wrtlcd
        movwf    bytelcd
        andlw    b'11110000'		; Mask out bottom nibble
        iorlw    b'00000011'		; set RS = 1, ENA = 1
        movwf    PORTB			; move nibble to PORTB
        bcf      PORTB,E		; Clock it in with enable
        call     delcd			; wait just a moment
        swapf    bytelcd,w		; swap nibbles in bytelcd in W
        andlw    b'11110000'
        iorlw    b'00000011'
        movwf    PORTB
        bcf      PORTB,E
        call     delcd
	return

;************************************************************************
;       Locate cursor on LCD
;	W = D7-D4 row, D3 - D0 col

; lcd_locate

;************************************************************************
;       Routine that checks for keypresses while waiting

test_ra2
	btfss   PORTA, 2		; when button 3 is pressed (= LO)
	goto    keymonitor		; monitor RA2
	return
	
;***** routine that diagnoses possible keypresses (RA2)

keymonitor
	
	btfsc   screen,2		; screen 4 ?
	goto	  boucl0
	incf    screen,f		; !!!! permet d'avoir 4 screens
boucl1
	call    screen_display		; this only to give fast reaction
	call    clrLCD
	movfw   screen
	iorlw   0x30
	call    wrtlcd
					; to keypresses. data may (will)
	movlw   d'10'			; not be valid.
	call    del_var			; debounce pause 300ms
	return 
boucl0                         
	clrf    screen
	goto	  boucl1
;************************************************************************
;* SERIAL RECEIVE
;************************************************************************	
;       Serial is inverted:
;       0V on Port-A,0 indicates a logic '1'
;       5V on Port-A,0 indicates a logic '0'

serialReceive
	clrf	serialData
	btfsc   SERIAL_IN               ; Check for Start bit
        goto	serialReceive		; not receiving now
	movlw   D'8'                    
	movwf   serialCount             ; gonna read 9 bits
	call    serialDelayThird        ; skip third a bit
	call    serialDelay		; skip a bit
serialReceiveLoop
	setc                            ; assume clear carry
	btfss   SERIAL_IN               ; if receiving 0
	clrc                            ; set carry
	rrf     serialData, F           ; roll serialData bits  
	call    serialDelay             ; delay
	nop                             ; keep timing w/ transmit
	decfsz  serialCount, F          ; if not complete
	goto    serialReceiveLoop       ; loop back for more
;	call    serialDelay             ; Dump the Parity Bit...
	return

;************************************************************************
; GET DATA (as a packet input through the serial IN port, every second) * 
;************************************************************************
; The packet length is limited to 56 bytes by the value in "counter" .
; Data is stored in the order of reception, fits the pre-defined raw data block
; 
get_data
	movlw   0x0C			; Start of Ram Data to save
	movwf   fsr
      movlw   d'56'			; Number of bytes to store (56)
	movwf   counter
getdat1
	call    serialReceive		; wait for one byte
	movf    serialData,W
	movwf   indf			; Store to where FSR points
	incf    fsr,f
	decfsz  counter,F		; Decrement Count until we got them all
        goto    getdat1
	return

;************************************************************************
;       which screen to display; (based on $GPRMC sentence)
;
;       0. screen with    Latitude      speed
;			  Longitude	course
;
;	1. screen with	  Time
;			  Date
;
;       2. screen with    Latitude .xxx
;			  Longitude .yyy
;
;	3. screen with    Status & Altitude
;

screen_display
	call    clrLCD
	movfw   screen
	addwf   pcl,f

	goto  screen0                 ; Lat/Lon
      goto  screen1                 ; Time/Date
      goto	screen2                 ; Lat/Lon .xxx/.yyy
      goto	screen3			; Status & Altitude
	goto	screen4			; !!!! direction et vitesse en km/h

	return


screen0
        call    clrLCD
	call    disp_lat                ; first the latitude
	call	send_CRLF		; go to the second line of the display
        call    disp_lon                ; now longitude
        call	disp_valid		; show if data is vAlid or Verbose
        call	disp_speed
	call	disp_course		; and display the course
	return


screen1
        call    clrLCD
	call    disp_time		; first the TIME UTC
	call	send_CRLF		; go to the second line of the display
        call    disp_date		; now DATE
        return

screen2
	call    clrLCD
	call    disp_lat_long		; first the latitude .xxx
	call	disp_valid		; show if data is valid (1) or verbose (0)
	call	send_CRLF		; go to the second line of the display
	call    disp_lon_long           ; now longitude .yyy
	return

screen4					; !!!! ajout display vitesse en km/h et cap
	call    clrLCD			; efface ecran
	call    disp_vite			; 
	call	  send_CRLF			; go to the second line of the display
	call    disp_cap			; 
	return


screen3
	call    clrLCD
	movlw   EE_str3			; start of 3st string
	call    EE_panel		; show the 1st line
	call	send_CRLF
	call	count_gga
num_sat
	incf	fsr,f
	movf    indf,W			; See if it is ","
	sublw   0x2C
	skpz 
	goto	num_sat
	decf	fsr,f
	movlw   0xC1			; Row 2 Col 7
	movwf	temp			; save cursor position
        call	rev_write		; display n sat chr
	incf	fsr,f			; init hdop
	call	comma_loop
hdop_dot
	incf	fsr,f
	movf    indf,w
	sublw   0x2E			; is a dot?
	skpz
	goto	hdop_dot
	incf	fsr,f
	movlw   0xC7			; Row 2 Col 7
	movwf	temp			; save cursor position
        call	rev_write		; display HDOP4 chr
        
; test n sat for altitude display

	call	count_gga
	btfsc   indf, 0
	goto	disp_alt
	incf	fsr,f
	btfsc   indf, 2			; not display Altitude if Satellite < 4
	goto	disp_alt
	btfsc   indf, 3
	goto	disp_alt
	return

disp_alt
	call	comma_loop
	call	comma_loop
	call	comma_loop
	movlw   0xCF			; Row 2 Col 16
	call    cmdlcd			; send command
	movf    indf,w
	call    wrtlcd                  ; display "M" chr
	movlw   0xCD			; set Row 2 Col 14
	movwf	temp			; save cursor position
        
disp_alt_loop
        decf	fsr,f
        movf    indf,w
	sublw   0x2E			; is a dot?
	skpz
	goto	disp_alt_loop
	decf	fsr,f			; point last chr before point
	goto    rev_write
	
count_gga
	call	comma_count
	call	comma_loop
	call	comma_loop
	call	comma_loop
	call	comma_loop
	call	comma_loop
	return

;************************************************************************
main00
        clrf    STATUS                  ; Do Initialization (Bank 0)
; Initialize Ports, Timers and data variables
        clrf    PORTA
        clrf    PORTB
        clrf    screen


; now set the various IO ports for input and output

	bsf STATUS,RP0			; Point to bank 1 to access special registers
					; port A all inputs from reset
        movlw   b'00000101'             ; port RA1 output, RA0 & RA2 for input
        movwf   TRISA                   ; other porta ports for output
        clrf    TRISB			; port b all ports for output
	bcf STATUS,RP0			; Point to bank 0 to access RAM variables

;       initialization of LCD display and display welcome message

init_all
	call     inilcd			; initialise the LCD
        movlw    EE_str1                ; start of 1st string
        call     EE_panel		; show the openingscreen
        call	 send_CRLF
        movlw    EE_str2                ; start of 2nd string
	call     EE_panel               ; show the openingscreen
        call     del_long               ; and allow time to press the setup key
       
;       Finished initialization, now for program loop.

main_loop
	call    test_ra2		; checks for keypresses
	movfw   screen
	addwf   pcl,f
	goto    loop_rmc
	goto    loop_rmc
	goto	  loop_rmc
      goto	  loop_gga
	goto	  loop_vtg		; !!!! trame contenant vitesse en km/h

loop_rmc
	call    serialReceive          	; Wait for data byte
					; Data Packet starts with $GPRMC.
	movf    serialData,W   		; See if serialData = "R"
	sublw   0x52
	skpz
	goto    loop_rmc	       	; Not start of message
        call    serialReceive
	movf    serialData,W  	 	; See if it is "M"
	sublw   0x4D
	skpz
	goto    loop_rmc	      	; Not start of message, nothing else to do
	call    serialReceive
	movf    serialData,W   		; See if it is "C"
	sublw   0x43
	skpz
	goto    loop_rmc	       	; Not start of message, nothing else to do
	call    serialReceive
	movf    serialData,W  	 	; See if it is ","
	sublw   0x2C
	skpz
	goto    loop_rmc
	call	get_data		; now there are new data to be got
	call    screen_display		; a little bit more structured;
	goto	main_loop		; we are ready to start again

loop_gga
	call    serialReceive          	; Wait for data byte
					; Data Packet starts with $GPGGA.
	movf    serialData,W   		; See if serialData = "G"
	sublw   0x47
	skpz
	goto    loop_gga	       	; Not start of message
        call    serialReceive
	movf    serialData,W  	 	; See if it is "G"
	sublw   0x47
	skpz
	goto    loop_gga	      	; Not start of message, nothing else to do
	call    serialReceive
	movf    serialData,W   		; See if it is "A"
	sublw   0x41
	skpz
	goto    loop_gga	       	; Not start of message, nothing else to do
	call    serialReceive
	movf    serialData,W  	 	; See if it is ","
	sublw   0x2C
	skpz
	goto    loop_gga
	call	get_data		; now there are new data to be got
	call    screen_display		; a little bit more structured;
	goto	main_loop		; we are ready to start again

loop_vtg						; !!!! ajout traitement trame VTG
	call    serialReceive          	; Wait for data byte
					; Data Packet starts with $GPVTG.
	movf    serialData,W   		; See if serialData = "V"
	sublw   0x56
	skpz
	goto    loop_vtg	       	; Not start of message
      call    serialReceive
	movf    serialData,W  	 	; See if it is "T"
	sublw   0x54
	skpz
	goto    loop_vtg	      	; Not start of message, nothing else to do
	call    serialReceive
	movf    serialData,W   		; See if it is "G"
	sublw   0x47
	skpz
	goto    loop_vtg	       	; Not start of message, nothing else to do
	call    serialReceive
	movf    serialData,W  	 	; See if it is ","
	sublw   0x2C
	skpz
	goto    loop_vtg
	
	call	get_data 
	call    screen_display		; a little bit more structured;
	goto	main_loop		; we are ready to start again

	
;************************************************************************
;************************************************************************
; PROCESS DATA 						                *
;************************************************************************
; routine that processes the buffered data:
;
;************************************************************************
; DISPLAY LATITUDE -
;************************************************************************
; routine displays the latitude, followed by a space ;
;    - block lenght 11 pos.

disp_lat
        call	comma_count
        call	comma_loop		; point after comma2
        movf    indf,w
        call    wrtlcd                  ; display lat1 chr
        incf    fsr,f
        movf    indf,w
	call    wrtlcd                  ; display lat2 chr
        incf    fsr,f
        movlw   0xdf                    ; print degree symbol 3 chr
        call    wrtlcd
        movf    indf,w
	call    wrtlcd                  ; display lat_min1 chr
        incf    fsr,f
        movf    indf,w
	call    wrtlcd                  ; display lat_min2 chr
        incf    fsr,f
        movf    indf,w
	call    wrtlcd                  ; display a dot chr
        incf    fsr,f       
        movf    indf,w
	call    wrtlcd                  ; display lat_dec1 chr
        incf    fsr,f        
        movf    indf,w
	call    wrtlcd                  ; display lat_dec2 chr
        incf    fsr,f            
        call	comma_loop        
        call    sendBlank		; display 9^ chr
        movf    indf,w
	call    wrtlcd                  ; display N/S chr
	return

disp_lat_long
	call	comma_count
        call	comma_loop		; point after comma2
        movf    indf,w
        call    wrtlcd                  ; display lat1 chr
        incf    fsr,f
        movf    indf,w
	call    wrtlcd                  ; display lat2 chr
        incf    fsr,f
        movlw   0xdf                    ; print degree symbol 3 chr
        call    wrtlcd
        movf    indf,w
	call    wrtlcd                  ; display lat_min1 chr
        incf    fsr,f
        movf    indf,w
	call    wrtlcd                  ; display lat_min2 chr
        incf    fsr,f
        movf    indf,w
	call    wrtlcd                  ; display a dot chr
        incf    fsr,f       
        movf    indf,w
	call    wrtlcd                  ; display lat_dec1 chr
        incf    fsr,f        
        movf    indf,w
	call    wrtlcd                  ; display lat_dec2 chr
        incf    fsr,f            
        movf    indf,W			; See if it is ","
	sublw   0x2C
	skpnz 
	goto	end_lat_long
	movf    indf,w
	call    wrtlcd                  ; display lat_dec3 chr
        incf    fsr,f 
        movf    indf,W			; See if it is ","
	sublw   0x2C
	skpnz 
	goto	end_lat_long
	movf    indf,w
	call    wrtlcd 			; display lat_dec4 chr
pass_lat
	incf    fsr,f 
	movf    indf,W			; See if it is ","
	sublw   0x2C
	skpnz 
	goto	end_lat_long
	goto	pass_lat
end_lat_long	
        incf    fsr,f 
        call    sendBlank		; display 11^ chr
        movf    indf,w
	call    wrtlcd                  ; display N/S chr
	return
	
;************************************************************************
; DISPLAY LONGITUDE: - 						        *
;************************************************************************
; routine displays the longitude, followed by a space ;
;    - block lenght 11/12 pos.
disp_lon
	call	comma_loop
        movf    indf,w
        call    wrtlcd                  ; display lon1 chr
        incf    fsr,f
        movf    indf,w
	call    wrtlcd                  ; display lon2 chr
        incf    fsr,f
        movf    indf,w
	call    wrtlcd                  ; display lon3 chr
        incf    fsr,f
        movlw   0xdf                    ; print degree symbol 4 chr
        call    wrtlcd
        movf    indf,w
	call    wrtlcd                  ; display lon_min1 chr
        incf    fsr,f
        movf    indf,w
	call    wrtlcd                  ; display lon_min2 chr
        incf    fsr,f
        movf    indf,w
	call    wrtlcd                  ; display a dot chr
        incf    fsr,f       
        movf    indf,w
	call    wrtlcd                  ; display lon_dec1 chr
        incf    fsr,f        
        movf    indf,w
	call    wrtlcd                  ; display lon_dec2 chr
        incf    fsr,f            
        call	comma_loop        
        call    sendBlank		; display 9^ chr
        movf    indf,w
	call    wrtlcd                  ; display E/W chr
	return

disp_lon_long
	call	comma_count
	call	comma_loop
	call	comma_loop
	call	comma_loop		;skip 4 comma
        movf    indf,w
        call    wrtlcd                  ; display lon1 chr
        incf    fsr,f
        movf    indf,w
	call    wrtlcd                  ; display lon2 chr
        incf    fsr,f
        movf    indf,w
	call    wrtlcd                  ; display lon3 chr
	incf    fsr,f
        movlw   0xdf                    ; print degree symbol 3 chr
        call    wrtlcd
        movf    indf,w
	call    wrtlcd                  ; display lon_min1 chr
        incf    fsr,f
        movf    indf,w
	call    wrtlcd                  ; display lon_min2 chr
        incf    fsr,f
        movf    indf,w
	call    wrtlcd                  ; display a dot chr
        incf    fsr,f       
        movf    indf,w
	call    wrtlcd                  ; display lon_dec1 chr
        incf    fsr,f        
        movf    indf,w
	call    wrtlcd                  ; display lon_dec2 chr
        incf    fsr,f            
        movf    indf,W			; See if it is ","
	sublw   0x2C
	skpnz 
	goto	end_lon_long
	movf    indf,w
	call    wrtlcd                  ; display lon_dec3 chr
        incf    fsr,f 
        movf    indf,W			; See if it is ","
	sublw   0x2C
	skpnz 
	goto	end_lon_long
	movf    indf,w
	call    wrtlcd 			; display lon_dec4 chr
pass_lon
	incf    fsr,f 
	movf    indf,W			; See if it is ","
	sublw   0x2C
	skpnz 
	goto	end_lon_long
	goto	pass_lon
end_lon_long	
        incf    fsr,f 
        call    sendBlank		; display 12^ chr
        movf    indf,w
	call    wrtlcd                  ; display E/W chr
	return
	
;************************************************************************
; DISPLAY IF DATA ARE VALIDE OR NOT: - 					*
;************************************************************************
; routine display the VALIDITY - blocklength 1

disp_valid
	call	comma_count
	movf    indf,w
	sublw   0x56
	skpz
	goto	valid_data
	movlw	0x3F			; display "?" chr
	call    wrtlcd
	call	sendBlank
	return
	  
valid_data
	movlw	b'01111110'		; display "->" chr
	call    wrtlcd
	call	sendBlank
	return
;******************************************************

disp_vite				; !!!! disp vitesse en km/h
	call	comma_count
	call	comma_loop
	call	comma_loop
	call	comma_loop
	call	comma_loop
	call	comma_loop
	call	comma_loop
	goto	ma_routine


disp_cap
	
	movlw   0xcd			; Row 2 Col 14
	call    cmdlcd			; send command

	movlw	  0x0C
	movwf	  fsr

	movf    indf,w
	call    wrtlcd                  ; display 1 chr

	incf    fsr,f
	movf    indf,w
	call    wrtlcd                  ; display 2 chr

	incf    fsr,f 
	movf    indf,w
	call    wrtlcd                  ; display 3 chr

	return
	


;************************************************************************
;  DISPLAY SPEED                                                        *
;************************************************************************
; routine displays the speed
; output blocklength: 5 - no spaces in front or after data

disp_speed
	call	comma_count
	call	comma_loop
	call	comma_loop
	call	comma_loop
	call	comma_loop
	call	comma_loop
	call	comma_loop
ma_routine
	movlw   0x8F			; Row 1 Col 16
	movwf	temp			; save cursor position
	call    cmdlcd			; send command
speed_dot
	decf	fsr,f
	movf    indf,w
	sublw   0x2E			; is a dot?
	skpz
	goto	speed_dot
	incf	fsr,f
	movf    indf,w
	call    wrtlcd                  ; display decimal chr
	movlw   0x8E			; Row 1 Col 16
	movwf	temp			; save cursor position
        decf    fsr,f
        call	rev_write
        incf	fsr,f
        return
        
;************************************************************************
; DISPLAY COURSE: - 						        *
;************************************************************************
; routine display the COURSE in degrees from N - blocklength 3

disp_course
	call	comma_loop
	movlw   0xcd			; Row 2 Col 14
	call    cmdlcd			; send command
	movf    indf,w
	call    wrtlcd                  ; display 1 chr
	incf    fsr,f
	movf    indf,w
	call    wrtlcd                  ; display 2 chr
	incf    fsr,f 
	movf    indf,w
	call    wrtlcd                  ; display 3 chr
	return
	
;************************************************************************
;  DISPLAY TIME                                                         *
;************************************************************************
; routine displays the TIME
; output blocklength: 12 - no spaces in front or after data

disp_time	
	movf    dato1, w
        call    wrtlcd                  ; display 1 chr
        movf    dato2, w
        call    wrtlcd                  ; display 2 chr
        movlw	0x3A
        call    wrtlcd			; display : chr
        movf    dato3, w
        call    wrtlcd                  ; display 4 chr
        movf    dato4, w                
        call    wrtlcd                  ; display 5 chr
        movlw	0x3A
        call    wrtlcd                  ; display : chr
        movf    dato5, w
        call    wrtlcd                  ; display 7 chr
        movf    dato6, w
        call    wrtlcd                  ; display 8 chr
        call	sendBlank		; display a space chr
        movlw	0x55
        call    wrtlcd                  ; display U chr
        movlw	0x54
        call    wrtlcd                  ; display T chr
        movlw	0x43
        call    wrtlcd                  ; display C chr
	return

;************************************************************************
;  DISPLAY DATE                                                        *
;************************************************************************
; routine displays the DATE
; output blocklength: 8 - no spaces in front or after data

disp_date
	call	comma_count
	call	comma_loop
	call	comma_loop
	call	comma_loop
	call	comma_loop
	call	comma_loop
	call	comma_loop
	call	comma_loop
	movf    indf,w
	call    wrtlcd                  ; display d1 chr
        incf    fsr,f 
        movf    indf,w
	call    wrtlcd                  ; display d2 chr
        incf    fsr,f 
        movlw	0x2F
        call    wrtlcd			; display / chr
        movf    indf,w
	call    wrtlcd                  ; display m1 chr
        incf    fsr,f 
        movf    indf,w
	call    wrtlcd                  ; display m2 chr
        incf    fsr,f 
        movlw	0x2F
        call    wrtlcd                  ; display / chr
        movf    indf,w
	call    wrtlcd                  ; display y1 chr
        incf    fsr,f 
        movf    indf,w
	call    wrtlcd                  ; display y2 chr
	return
	
;************************************************************************
; COMMA COUNT
;************************************************************************
; count comma before data string

comma_count
	movlw   0x0C			; Start of Ram Data
	movwf   fsr
comma_loop	
	movf    indf,w			; See if it is ","
	sublw   0x2C
	skpnz 
	goto	comma			; 
	incf    fsr,f
        goto    comma_loop
comma
	incf    fsr,f
	return

;************************************************************************
; String reverse write

rev_write
	movf	temp,w
	call	cmdlcd
	movf    indf,w
	sublw   0x2C			; is a comma?
	skpnz
	return
	movf	indf,w
	call    wrtlcd                  ; display a chr
        decf    fsr,f
        decf	temp,f
	goto	rev_write
	
;************************************************************************
;       Routine to display strings on the LCD Display from EE_prom

EE_panel
        movwf   EEADR
EE_pan1
        call    EE_Read          	; displ. char in table
        andlw   0xff                    ; test for delimiter
        skpnz
        return
        call    wrtlcd
        incf    EEADR, f            	; next char
        goto    EE_pan1                 ; display the next char in table
        return                          ; else return

EE_Read
	bcf	STATUS,RP1
	bsf	STATUS,RP0                 ;
	bsf 	EECON1,RD  		; enable read flag
	bcf	STATUS,RP0
	movf 	EEDATA,W   		; read eeprom data now in EEDATA into W 
	return          		; and return


;************************************************************************
; various delay routines.
;
; routine for long delay; 'w' times 50ms  ( 'w' argument in w) ;
del_long
                movlw   d'20'
del_var					; entry for variable delay
                movwf   counter		; into count
long1           call    del50		; call the 50 msec delay
		decfsz  counter,f
                goto    long1
		return						

;       Routine to delay 50 mS
del50
        movlw    d'98'			; Start count at 98
	movwf    rit1			; 
del51
	movlw    d'100'			; Do it 100 times
	movwf    rit2
del52
	decfsz   rit2,1			; decrement counter2
	goto     del52			; if counter2 > 0 do it again
	decfsz   rit1,1			; if counter2 = 0 decr. counter1        
	goto     del51			; if counter1 > 0 do it again
endel50
	return				; end routine

;       Routine per delay 2 mS
del05
        movlw    d'18'			; Start with a count of 18
	movwf    rit1			; 
del051
        movlw    d'33'			; and do it 33 times 0.1 ms each
	movwf    rit2
del052
					; internal loop needs 3 usec
	decfsz   rit2,1			; decrement counter2
	goto     del052			; if counter2 > 0 do it again
	decfsz   rit1,1			; if counter2 = 0 decr. counter1        
	goto     del051			; if counter1 > 0 do it again
endl05
	return				; end routine

;       Routine per delay 0.1 mS
delcd
        movlw    d'34'			; Count 34 times
	movwf    rit1
delcd1  
					; internal loop needs 3 usec
        decfsz   rit1,1			; if counter > 0 do it again
	goto     delcd1         
	return				; end routine
;
;************************************************************************
;* SERIAL DELAY
;
;* W = Requested delay time in uS/3 (clock = 4Mhz)
;************************************************************************

serialDelayThird
	movlw   DELAY_TIME/3            
	movwf   serialDelayCount        ; only count 1/3
	goto    serialDelayLoop         ; use routine below
serialDelay
	movlw   DELAY_TIME              
	movwf   serialDelayCount        ; Count down from DELAY_TIME
	nop                             ; Helps with high speed
serialDelayLoop
	decfsz  serialDelayCount,F	; Countdown
	 goto   serialDelayLoop         ; keep counting
	return                          ; done
;
;________________________________________________________________________
  
	org 0x2100
	
EE_str1 DE      "GPS NMEA Display", 0
EE_str2 DE      "     V. 1.4", 0
EE_str3 DE      "Sat HDOP Altit U", 0

	end